关于在生产环境下的package.json的依赖包版本问题

知道能通过"~" "^" 来限制依赖包的更新;
项目使用vue-cli;

我想问问:
对于【线上运行的项目】,
不管dependencies还是devDependencies,
是所有都使用固定版本(比如1.0.0)比较好,还是统一用"~"前缀比较好

我现在是:
dependencies中除了一些插件(比如:swiper、clipboard)使用"~"前缀,其他都是固定版本号(比如:vue、vue-router)。
devDependencies中全部使用"~"前缀,
不知道这样会不会有什么问题?

或者大家一般都怎么控制版本号的?

阅读 474
评论
    2 个回答
    • 543

    请参考https://docs.npmjs.com/misc/s...

    回到问题。
    你指的固定版本号是什么?看问题描述似乎是^1.0.0这种。但其实固定版本号就是固定版本1.0.0,所以这个要先明确。

    然后说^和~的区别。
    ^1.2.3 := >=1.2.3 && < 2.0.0
    ~1.2.3 := >=1.2.3 && < 1.3.0
    一个是在主要版本内都OK,另一个是只在小版本内没问题,即只有补丁没问题。
    根据定义,当项目的结构有重大变化或者API有巨大调整时,变更主版本号。而在新增API时,应只调整次要版本号。在修复缺陷时,应只调整补丁版本号。
    在遵守此规范下,理论上只会在主版本号变动时,会造成breaking change,所以为什么save命令写入的是^形式的。

      一般来说,当前的大版本发也是发那种修复的版本,锁版本更安心点,不锁也不是不可以

        撰写回答

        登录后参与交流、获取后续更新提醒